package org.wamblee.support.persistence.hibernate;

import java.util.Map;

import org.dbunit.dataset.filter.ITableFilterSimple;
import org.wamblee.support.persistence.JpaCustomizer;
import org.wamblee.support.persistence.PersistenceUnitDescription;

public class HibernateJpaCustomizer implements JpaCustomizer {

    public HibernateJpaCustomizer() { 
        // Empty
    }
    
    @Override
    public void customize(PersistenceUnitDescription aPersistenceUnit, Map<String, String> aJpaProperties) {
        // Hibernate: Override transaction type and datasource
        aJpaProperties.put("javax.persistence.transactionType", "RESOURCE_LOCAL");
        aJpaProperties.put("javax.persistence.jtaDataSource", null);
        aJpaProperties.put("javax.persistence.nonJtaDataSource", aPersistenceUnit.getJndiName());
        
        // Hibernate schema generation
        aJpaProperties.put("hibernate.hbm2ddl.auto", "create");     
    }
    
    @Override
    public ITableFilterSimple getJpaTables() {
        return new HibernateTables();
    }

}
